//
// Copyright (C) 2013　Taiyou Sakashita
//
// Flat binary Reader and Writer 2014/02/07
//

float  Convertf(float  valf);


void bin2d(char *filename, int X, int Y, double *double_num)
{

  int I,J;

  // Read Data
  float read_data[2];

  FILE *fp;

  if((fp = fopen(filename, "rb")) == NULL) {printf("file read error.\n"); exit(1);}

  printf("%s   Loading...", filename);

  for(I=1;I<=Y;I++)
  {
     for(J=1;J<=X;J++)
     {

        fread(&read_data[1], sizeof(float), 1, fp);
        double_num[(I-1)*X+J] = (double)Convertf(read_data[1]);

     }
  }

  printf("finish\n");

  fclose(fp);

  return;

}//bin2d


void bin2f(char *filename, int X, int Y, float *float_num)
{

  int I,J;

  // Read Data
  float read_data[2];

  FILE *fp;

  if((fp = fopen(filename, "rb")) == NULL) {printf("file read error.\n"); exit(1);}

  printf("%s   Loading...", filename);

  for(I=1;I<=Y;I++)
  {
     for(J=1;J<=X;J++)
     {

        fread(&read_data[1], sizeof(float), 1, fp);
        float_num[(I-1)*X+J] = (float)Convertf(read_data[1]);

     }
  }

  printf("finish\n");

  fclose(fp);

  return;

}//bin2f


void d2bin(char *filename, int X, int Y, double *double_num)
{

  int I,J;

  // Write Data
  float write_data[2];

  FILE *fp;

  if((fp = fopen(filename, "wb")) == NULL) {printf("file write error.\n"); exit(1);}

  printf("%s   Writing...", filename);

  for(I=1;I<=Y;I++)
  {
     for(J=1;J<=X;J++)
     {

        write_data[1] = Convertf((float)double_num[(I-1)*X+J]);
        fwrite(&write_data[1], sizeof(float), 1, fp);

     }//J
  }//I

  printf("finish\n");

  fclose(fp);

  return;

}//d2bin


void f2bin(char *filename, int X, int Y, float *float_num)
{

  int I,J;

  // Write Data
  float write_data[2];

  FILE *fp;

  if((fp = fopen(filename, "wb")) == NULL) {printf("file write error.\n"); exit(1);}

  printf("%s   Writing...", filename);

  for(I=1;I<=Y;I++)
  {
     for(J=1;J<=X;J++)
     {

        write_data[1] = Convertf((float)float_num[(I-1)*X+J]);
        fwrite(&write_data[1], sizeof(float), 1, fp);

     }//J
  }//I

  printf("finish\n");

  fclose(fp);

  return;

}//f2bin




float Convertf(float valf)
{

	int val;

	memcpy(&val,&valf,sizeof(val)); // Not BitShift float
	val = ((val<<24) & 0xff000000) | ((val<<8) & 0x00ff0000) | ((val>>8) & 0x0000ff00) | ((val>>24) & 0x000000ff) ;
	memcpy(&valf,&val,sizeof(valf));

	return valf;
}//Convertf

